<?php

namespace Ems\portalGestor\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Error};

use Ems\portalGestor\Service\QuadroGeralVinculoService;

class QuadroGeralVinculoController {
    /** @var QuadroGeralVinculoService */
    protected $quadroGeralVinculoService;

    public function __construct(
        QuadroGeralVinculoService $quadroGeralVinculoService
    ) {
        $this->quadroGeralVinculoService = $quadroGeralVinculoService;
    }
    public function getQuadroGeralVinculo(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();
            $quadroGeralVinculo = $this->quadroGeralVinculoService->getQuadroGeralVinculo(
                $row
            );

            $response->addDataSet(new DataSet('data', $quadroGeralVinculo));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace(), $e));
        }
    }
}