/* Tabela PRODUTOAP: PRODUTOAP */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PRODUTOAP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela PRODUTOAP,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_PRODUTOAP
AFTER DELETE OR INSERT OR UPDATE
ON PRODUTOAP FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdProduto=' || :OLD.CDPRODUTO;
      END IF;
     
      IF :OLD.DTCUSTOAP IS NOT NULL THEN
         V_DESC := V_DESC || ' DtCustoAp=' || :OLD.DTCUSTOAP;
      END IF;
      
      IF :OLD.VRMEDLIQAP IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMedLiqAp=' || :OLD.VRMEDLIQAP;
      END IF;
      
      IF :OLD.VRMEDBRUAP IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMedBruAp=' || :OLD.VRMEDBRUAP;
      END IF;
      
      IF :OLD.VRULTCLIQAP IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUltCliqAp=' || :OLD.VRULTCLIQAP;
      END IF;
      
      IF :OLD.VRULTCBRUAP IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUltcBruAp=' || :OLD.VRULTCBRUAP;
      END IF;
      
      IF :OLD.DTHRIMPCUSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrImpCusto=' || :OLD.DTHRIMPCUSTO;
      END IF;
     
      IF :OLD.CDOPIMPCUSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOpImpCusto=' || :OLD.CDOPIMPCUSTO;
      END IF;
      
      IF :OLD.CDOPALTCUSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOpAltCusto=' || :OLD.CDOPALTCUSTO;
      END IF;
      
      IF :OLD.DTULTATUPRAP IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtuPrAp=' || :OLD.DTULTATUPRAP;
      END IF;
      
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDPRODUTO || '|' || :OLD.DTCUSTOAP;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL     )OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO    )OR
            (:OLD.DTCUSTOAP    <> :NEW.DTCUSTOAP    )OR
            (:OLD.VRMEDLIQAP   <> :NEW.VRMEDLIQAP   )OR
            (:OLD.VRMEDBRUAP   <> :NEW.VRMEDBRUAP   )OR
            (:OLD.VRULTCLIQAP  <> :NEW.VRULTCLIQAP  )OR
            (:OLD.VRULTCBRUAP  <> :NEW.VRULTCBRUAP  )OR
            (:OLD.DTHRIMPCUSTO <> :NEW.DTHRIMPCUSTO )OR
            (:OLD.CDOPIMPCUSTO <> :NEW.CDOPIMPCUSTO )OR
            (NVL(:OLD.CDOPALTCUSTO, ' ')     <> NVL(:NEW.CDOPALTCUSTO, ' ')) OR
            (NVL(:OLD.DTULTATUPRAP, SYSDATE) <> NVL(:NEW.DTULTATUPRAP, SYSDATE))THEN
             
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDPRODUTO, ' ') <> NVL(:NEW.CDPRODUTO, ' ') THEN
               V_DESC := V_DESC || ' CdProduto=' || :OLD.CDPRODUTO || '|' || :NEW.CDPRODUTO;
            END IF;
            
            IF NVL(:OLD.DTCUSTOAP, SYSDATE) <> NVL(:NEW.DTCUSTOAP, SYSDATE) THEN
               V_DESC := V_DESC || ' DtCustoAp=' || :OLD.DTCUSTOAP || '|' || :NEW.DTCUSTOAP;
            END IF;
            
            IF NVL(:OLD.VRMEDLIQAP, 0) <> NVL(:NEW.VRMEDLIQAP, 0) THEN
               V_DESC := V_DESC || ' VrMedLiqAp=' || :OLD.VRMEDLIQAP || '|' || :NEW.VRMEDLIQAP;
            END IF;
            
            IF NVL(:OLD.VRMEDBRUAP, 0) <> NVL(:NEW.VRMEDBRUAP, 0) THEN
               V_DESC := V_DESC || ' VrMedBruAp=' || :OLD.VRMEDBRUAP || '|' || :NEW.VRMEDBRUAP;
            END IF;
            
            IF NVL(:OLD.VRULTCLIQAP, 0) <> NVL(:NEW.VRULTCLIQAP, 0) THEN
               V_DESC := V_DESC || ' VrUltCliqAp=' || :OLD.VRULTCLIQAP || '|' || :NEW.VRULTCLIQAP;
            END IF;
            
            IF NVL(:OLD.VRULTCBRUAP, 0) <> NVL(:NEW.VRULTCBRUAP, 0) THEN
               V_DESC := V_DESC || ' VrUltcBruAp=' || :OLD.VRULTCBRUAP || '|' || :NEW.VRULTCBRUAP;
            END IF;
            
            IF NVL(:OLD.DTHRIMPCUSTO, SYSDATE) <> NVL(:NEW.DTHRIMPCUSTO, SYSDATE) THEN
               V_DESC := V_DESC || ' DtHrImpCusto=' || :OLD.DTHRIMPCUSTO || '|' || :NEW.DTHRIMPCUSTO;
            END IF;
            
            IF NVL(:OLD.CDOPIMPCUSTO, ' ') <> NVL(:NEW.CDOPIMPCUSTO, ' ') THEN
               V_DESC := V_DESC || ' CdOpImpCusto=' || :OLD.CDOPIMPCUSTO || '|' || :NEW.CDOPIMPCUSTO;
            END IF;
            
            IF NVL(:OLD.CDOPALTCUSTO, ' ') <> NVL(:NEW.CDOPALTCUSTO, ' ') THEN
               V_DESC := V_DESC || ' CdOpAltCusto=' || :OLD.CDOPALTCUSTO || '|' || :NEW.CDOPALTCUSTO;
            END IF;
            
            IF NVL(:OLD.DTULTATUPRAP, SYSDATE) <> NVL(:NEW.DTULTATUPRAP, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtuPrAp=' || :OLD.DTULTATUPRAP || '|' || :NEW.DTULTATUPRAP;
            END IF;
                                     
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDPRODUTO || '|' || :OLD.DTCUSTOAP;
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
         
         IF NVL(:OLD.CDPRODUTO, ' ') <> NVL(:NEW.CDPRODUTO, ' ') THEN
            V_DESC := V_DESC || ' CdProduto=' || :NEW.CDPRODUTO;
         END IF;
         
         IF NVL(:OLD.DTCUSTOAP, SYSDATE) <> NVL(:NEW.DTCUSTOAP, SYSDATE) THEN
            V_DESC := V_DESC || ' DtCustoAp=' || :NEW.DTCUSTOAP;
         END IF;
         
         IF NVL(:OLD.VRMEDLIQAP, 0) <> NVL(:NEW.VRMEDLIQAP, 0) THEN
            V_DESC := V_DESC || ' VrMedLiqAp=' || :NEW.VRMEDLIQAP;
         END IF;
         
         IF NVL(:OLD.VRMEDBRUAP, 0) <> NVL(:NEW.VRMEDBRUAP, 0) THEN
            V_DESC := V_DESC || ' VrMedBruAp=' || :NEW.VRMEDBRUAP;
         END IF;
         
         IF NVL(:OLD.VRULTCLIQAP, 0) <> NVL(:NEW.VRULTCLIQAP, 0) THEN
            V_DESC := V_DESC || ' VrUltCliqAp=' || :NEW.VRULTCLIQAP;
         END IF;
         
         IF NVL(:OLD.VRULTCBRUAP, 0) <> NVL(:NEW.VRULTCBRUAP, 0) THEN
            V_DESC := V_DESC || ' VrUltcBruAp=' || :NEW.VRULTCBRUAP;
         END IF;
         
         IF NVL(:OLD.DTHRIMPCUSTO, SYSDATE) <> NVL(:NEW.DTHRIMPCUSTO, SYSDATE) THEN
            V_DESC := V_DESC || ' DtHrImpCusto=' || :NEW.DTHRIMPCUSTO;
         END IF;
         
         IF NVL(:OLD.CDOPIMPCUSTO, ' ') <> NVL(:NEW.CDOPIMPCUSTO, ' ') THEN
            V_DESC := V_DESC || ' CdOpImpCusto=' || :NEW.CDOPIMPCUSTO;
         END IF;
         
         IF NVL(:OLD.CDOPALTCUSTO, ' ') <> NVL(:NEW.CDOPALTCUSTO, ' ') THEN
            V_DESC := V_DESC || ' CdOpAltCusto=' || :NEW.CDOPALTCUSTO;
         END IF;
         
         IF NVL(:OLD.DTULTATUPRAP, SYSDATE) <> NVL(:NEW.DTULTATUPRAP, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtuPrAp=' || :NEW.DTULTATUPRAP;
         END IF;
              
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || '|' || :NEW.CDPRODUTO || '|' || :NEW.DTCUSTOAP;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PRODUTOAP', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_PRODUTOAP','5.85.xxx'); END;
/